#include "precompile.h"

#include <float.h>

#include "android.ai.h"
#include "android.h"
#include "room.h"
#include "metamgr.h"
#include "player.h"

const int SHUA_RANGE = 580;

/*
  追击
  攻击
  巡逻

  1、当可以攻击的时候攻击
  2、当可追击时追击
  3、其他巡逻
 */
AndroidAI::~AndroidAI()
{
}

void AndroidAI::Update(int delta_time)
{
    Human* hum = (Human*)owner;
    if (hum->poisoning) {
        hum->poisoning_time += delta_time;
    }
    state_elapsed_time += delta_time;
    if (hum->poisoning) {
        hum->UpdatePoisoning();
    }
    if (hum->dead) {
        return;
    }
    if (a8::HasBitFlag(hum->status, HS_NewBieGuideAndroid)) {
        UpdateNewBieNpc();
        return;
    }
    if (a8::HasBitFlag(hum->status, HS_LastAndroid)) {
        UpdateLastNpc();
        return;
    }
    if ((hum->room->GetRoomType() == RT_NewBrid ||
         hum->room->GetRoomType() == RT_MidBrid) &&
        hum->room->GetGasData().gas_mode != GasInactive &&
        hum->team_uuid.empty()
        ) {
        UpdateNewBieRoomLogic();
        return;
    }
    switch (state) {
    case AS_thinking:
        {
            if (state_elapsed_time > 1500 + rand() % 3000) {
                int rnd = rand();
                if (rnd % 100 < 30) {
                    ChangeToState(AS_moving);
                } else if (rnd % 100 < 50) {
                    ChangeToState(AS_attack);
                }
            }
        }
        break;
    case AS_moving:
        {
            if (state_elapsed_time < 1000 + rand() % 2000) {
                DoMove();
            } else {
                int rnd = rand();
                if (rnd % 100 < 30) {
                    ChangeToState(AS_thinking);
                } else if (rnd % 100 < 50) {
                    ChangeToState(AS_attack);
                }
            }
        }
        break;
    case AS_attack:
        {
            if ((state_elapsed_time < 3000 && last_target_) ||
                (state_elapsed_time < 1100)) {
                DoAttack();
            } else {
                int rnd = rand();
                if (rnd % 100 < 30) {
                    ChangeToState(AS_moving);
                } else if (rnd % 100 < 50) {
                    ChangeToState(AS_thinking);
                }
            }
        }
        break;
    }
}

void AndroidAI::ChangeToState(AndroidState_e to_state)
{
    state = to_state;
    state_elapsed_time = 0;
    switch (state) {
    case AS_moving:
        {
            Human* hum = (Human*)owner;
            hum->move_dir = a8::Vec2(1.0f, 0);
            hum->move_dir.Rotate(a8::RandAngle());
            hum->move_dir.Normalize();
            hum->attack_dir = hum->move_dir;
        }
        break;
    default:
        break;
    }
}

void AndroidAI::DoMove()
{
    Human* hum = (Human*)owner;
    if (hum->room->IsWaitingStart()) {
        return;
    }
    if (owner->UpdatedTimes() % 2 == 0) {
        Human* hum = (Human*)owner;
        int speed = std::max(1, (int)hum->GetSpeed());
        if (a8::HasBitFlag(hum->status, HS_NewBieGuideAndroid) &&
            hum->room->GetFrameNo() - hum->enable_frameno < SERVER_FRAME_RATE * 8) {
            hum->move_dir = hum->room->GetFirstNewBie()->GetPos() - hum->GetPos();
            hum->move_dir.Normalize();
        }
        for (int i = 0; i < speed; ++i) {
            a8::Vec2 old_pos = hum->GetPos();
            hum->SetPos(hum->GetPos() + hum->move_dir);
            if (hum->IsCollisionInMapService()) {
                hum->SetPos(old_pos);
                if (i == 0) {
                    hum->FindPathInMapService();
                }
                break;
            }
            hum->room->grid_service->MoveHuman(hum);
        }
    }
}

void AndroidAI::DoAttack()
{
    Human* hum = (Human*)owner;
    if (hum->room->IsWaitingStart()) {
        return;
    }
    if (hum->room->GetGasData().gas_mode == GasInactive) {
        return;
    }
    if (owner->UpdatedTimes() % 10 == 0) {
        Human* enemy = owner->room->FindEnemy((Human*)owner);
        if (enemy) {
            Human* sender = (Human*)owner;
            a8::Vec2 shot_dir = enemy->GetPos() - sender->GetPos();
            if (std::abs(shot_dir.x) > FLT_EPSILON ||
                std::abs(shot_dir.y) > FLT_EPSILON) {
                shot_dir.Normalize();
                shot_dir.Rotate((rand() % 10) / 180.0f);
                sender->attack_dir = shot_dir;
                bool shot_ok = false;
                sender->Shot(shot_dir, shot_ok);
            }
        }
        last_target_ = enemy;
    }
}

void AndroidAI::UpdateNewBieNpc()
{
    Human* hum = (Human*)owner;
    if (hum->room->GetFrameNo() - hum->enable_frameno < 2) {
        if (hum->GetPos().ManhattanDistance(hum->room->GetFirstNewBie()->GetPos()) > 100)  {
            hum->move_dir = hum->room->GetFirstNewBie()->GetPos() - hum->GetPos();
            hum->move_dir.Normalize();
        }
        hum->attack_dir = hum->move_dir;
        if (hum->curr_weapon->weapon_idx != 0) {
            hum->curr_weapon->ammo = MetaMgr::Instance()->newbie_first_robot_ammo;
        }
    } else if (hum->room->GetFrameNo() - hum->enable_frameno < SERVER_FRAME_RATE * 1.5) {
        int speed = std::max(1, (int)hum->GetSpeed());
        for (int i = 0; i < speed; ++i) {
            hum->SetPos(hum->GetPos() + hum->move_dir);
            hum->room->grid_service->MoveHuman(hum);
        }
    } else if (hum->room->GetFrameNo() - hum->enable_frameno < SERVER_FRAME_RATE * 3) {
        Human* enemy = hum->room->GetFirstNewBie();
        Human* sender = hum;
        a8::Vec2 shot_dir = enemy->GetPos() - sender->GetPos();
        if (std::abs(shot_dir.x) > FLT_EPSILON ||
            std::abs(shot_dir.y) > FLT_EPSILON) {
            shot_dir.Normalize();
            shot_dir.Rotate((rand() % 10) / 180.0f);
            sender->attack_dir = shot_dir;
            bool shot_ok = false;
            sender->Shot(shot_dir, shot_ok);
        }
    } else {
        a8::UnSetBitFlag(hum->status, HS_NewBieGuideAndroid);
    }
}


void AndroidAI::UpdateLastNpc()
{
    Human* hum = (Human*)owner;
    if (hum->room->GetFrameNo() - hum->enable_frameno < 2) {
        if (hum->GetPos().ManhattanDistance(hum->last_human_target->GetPos()) > 100) {
            hum->move_dir = hum->last_human_target->GetPos() - hum->GetPos();
            hum->move_dir.Normalize();
        }
        hum->attack_dir = hum->move_dir;
        if (hum->curr_weapon->weapon_idx != 0) {
            hum->curr_weapon->ammo = MetaMgr::Instance()->newbie_first_robot_ammo * 2;
        }
    } else if (hum->room->GetFrameNo() - hum->enable_frameno < SERVER_FRAME_RATE * 1.5) {
        int speed = std::max(1, (int)hum->GetSpeed());
        for (int i = 0; i < speed; ++i) {
            a8::Vec2 old_pos = hum->GetPos();
            hum->SetPos(hum->GetPos() + hum->move_dir);
            if (!hum->room->OverBorder(hum->GetPos(), hum->meta->i->radius())) {
                hum->room->grid_service->MoveHuman(hum);
            } else {
                hum->SetPos(old_pos);
                break;
            }
        }
    } else if (hum->room->GetFrameNo() - hum->enable_frameno < SERVER_FRAME_RATE * 3) {
        Human* enemy = hum->last_human_target;
        Human* sender = hum;
        a8::Vec2 shot_dir = enemy->GetPos() - sender->GetPos();
        if (std::abs(shot_dir.x) > FLT_EPSILON ||
            std::abs(shot_dir.y) > FLT_EPSILON) {
            shot_dir.Normalize();
            shot_dir.Rotate((rand() % 10) / 180.0f);
            sender->attack_dir = shot_dir;
            bool shot_ok = false;
            sender->Shot(shot_dir, shot_ok);
        }
    } else {
        a8::UnSetBitFlag(hum->status, HS_LastAndroid);
    }
}

void AndroidAI::UpdateNewBieRoomLogic()
{
    Human* hum = (Human*)owner;
    Human* old_last_target = last_target_;
    Human* target = last_target_;
    if ((last_target_ && last_target_->real_dead) || !last_target_) {
        if (hum->last_human_target && !hum->last_human_target->dead) {
            target = hum->last_human_target;
        } else {
            if (rand() % 100 < 70) {
                hum->room->TouchPlayerList
                    (
                     a8::XParams(),
                     [hum, &target] (Player* player, a8::XParams& param)
                     {
                         if (!player->dead && hum->team_id != player->team_id) {
                             if (!target) {
                                 target = player;
                             } else {
                                 if (hum->GetPos().ManhattanDistance(player->GetPos()) <
                                     hum->GetPos().ManhattanDistance(target->GetPos()))  {
                                     target = player;
                                 }
                             }
                         }
                     });
            } else {
                hum->room->TouchHumanList
                    (
                     a8::XParams(),
                     [hum, &target] (Human* huma, a8::XParams& param)
                     {
                         if (!huma->dead &&
                             huma->IsAndroid() &&
                             hum->team_id != huma->team_id &&
                             !a8::HasBitFlag(huma->status, HS_Disable)) {
                             if (!target) {
                                 target = huma;
                             } else {
                                 if (hum->GetPos().ManhattanDistance(huma->GetPos()) <
                                     hum->GetPos().ManhattanDistance(target->GetPos()))  {
                                     target = huma;
                                 }
                             }
                         }
                         return true;
                     });
            }
        }
        last_target_ = target;
    }
    if (!target) {
        return;
    }
    if (target->IsPlayer()) {
        if (hum->room->AliveCount() < 15) {
            if (hum->GetPos().ManhattanDistance(target->GetPos()) > 1000) {
                a8::Vec2 pos = target->GetPos();
                a8::Vec2 dir = target->move_dir;
                dir = a8::Vec2::UP;
                if (rand() % 100 < 1) {
                    dir.Rotate(a8::RandAngle() / 2.0f);
                } else {
                    dir.Rotate(a8::RandAngle());
                }
                pos = pos + dir * SHUA_RANGE;
                if (hum->room->OverBorder(pos, hum->GetRadius())) {
                    pos.x = target->GetPos().x;
                    if (hum->room->OverBorder(pos, hum->GetRadius())) {
                        pos = target->GetPos();
                    }
                }
                hum->SetPos(pos);
                hum->room->grid_service->MoveHuman(hum);
                hum->FindLocation();
                hum->RefreshView();
            }
        }
    }
    if (hum->GetPos().ManhattanDistance(target->GetPos()) > 180) {
        if (hum->GetPos().ManhattanDistance(target->GetPos()) > 650 &&
            hum->room->GetFrameNo() - last_findenemy_frameno_ > SERVER_FRAME_RATE * 3) {
            last_findenemy_frameno_ = hum->room->GetFrameNo();
            last_target_ = nullptr;
        } else {
            int speed = std::max(1, (int)hum->GetSpeed());
            hum->move_dir = target->GetPos() - hum->GetPos();
            hum->move_dir.Normalize();
            hum->attack_dir = hum->move_dir;
            speed *= 0.7;
            for (int i = 0; i < speed; ++i) {
                hum->SetPos(hum->GetPos() + hum->move_dir);
                hum->room->grid_service->MoveHuman(hum);
            }
        }
    } else {
        if (hum->room->GetFrameNo() - last_attack_frameno_ > SERVER_FRAME_RATE + (rand() % 15)) {
            last_attack_frameno_ = hum->room->GetFrameNo();
            Human* sender = (Human*)owner;
            a8::Vec2 shot_dir = target->GetPos() - sender->GetPos();
            if (std::abs(shot_dir.x) > FLT_EPSILON ||
                std::abs(shot_dir.y) > FLT_EPSILON) {
                shot_dir.Normalize();
                shot_dir.Rotate((rand() % 10) / 180.0f);
                sender->attack_dir = shot_dir;
                bool shot_ok = false;
                sender->Shot(shot_dir, shot_ok);
            }
        }
        if (old_last_target && last_target_ && old_last_target == last_target_) {
            ++series_attack_frames_;
        } else {
            series_attack_frames_ = 0;
        }
        if (series_attack_frames_ > SERVER_FRAME_RATE * 10 &&
            last_target_ && last_target_->IsAndroid()) {
            last_target_ = nullptr;
        }
    }
}
